/* printFunc.c  */
/*
printNonBinaryCode():
Denne funksjonen hentar ytterkoden til ein og ein brukar
fr fil, skriv den s ut p skjerm.
Blir kun kyrt om 'p' blir gitt p kommando-linja.

printBinaryCode():
Blir brukt til  skrive ut innerkodar,
delar av det feasible settet eller deler av hybridFP.(Har alle lik lengd)
Blir kun kyrt om 'p' blir gitt p kommando-linja.

helpInfo():
Ein funksjon som viser kor ein kan f brukarsttte.
Blir kun kyrt om 'h' blir gitt p kommando-linja.
*/

#include "bonehShaw.h"

/* Print Outer code (Non-binary) */
void printNonBinaryCode(cParam p)
{
  int i,j,k, blockLen;
  word mask, *code;
  FILE *fp;

  if ((fp = fopen(TXTFILE,"r")) == NULL)
    UOF; /* Unable to open the file */

  EOM((code = malloc(p.nrOfBlocksOC * sizeof(word))));

  blockLen = p.nrInBlockOC;

  /* 'mask' is used to mask out the current bits. First we
     set 'mask' such that we get the first number */
  mask = ULONG_MAX << (BS_WORD-p.nrOfBits);

  for(i=0;i<p.M;i++) {  /* For all users */
    printf("Codeword %i = ",i+1);
    fread(code, p.nrOfBlocksOC, sizeof(word),fp);

    for(j=0;j<p.nrOfBlocksOC;j++) { /* For all blocks */
      if (j==p.nrOfBlocksOC-1)
	blockLen = p.lenLastBlockOC;

      for(k=0;k<blockLen;k++)  /* For all numbers in the current block */
	printf("%u",(code[j] &
	   (mask >>(p.nrOfBits*k))) >> (BS_WORD-(p.nrOfBits*(k+1))));
    }
    printf("\n");
    blockLen = p.nrInBlockOC;
  }

  fclose(fp);
  free(code);
}

/* Print binary code */
void printBinaryCode(dword *innerCode, cParam p)
{
  int i,k,j,t,bits, len, count;
  char *str;

  EOM((str = malloc(p.n1)));

  k=0;
  len = BS_DWORD;

  for(i=0;i<p.nrOfBlocksIC;i++) {
    if(i==p.nrOfBlocksIC-1)
      len=p.lenLastBlockIC;

    for(j=0;j<len; j++,k++)
      str[k] = innerCode[i]&((dword)1<<(BS_DWORD-1-j))?'1':'0';
  }

  str[k] = '\0';

  printf("%s - Length %i\n", str, strlen(str));

  free(str);
}

/*void helpInfo(void)
{
  printf("Read the unix manual(man page) for help\n");
}*/

