/* setCodeParam.c */
/*
getCodeParam(): Hentar kode parameterar fr kommando-linja.
t(Antallet piratar) er ikkje tvungen input. Men ein fr ikkje
kyrt generering/sporing av hybridFP om t ikkje er gitt.

chkIfDigit(): Blir brukt for  kontrollera at parameterane gitt
p kommando-linja faktisk er tall.

setProp():
Set variablar som trengst nr ein skal lagre kodane i tabellar.
*/

#include "bonehShaw.h"

/* Get code parameters from command-line */
cParam getCodeParam(int argc,char *argv[])
{
  cParam p;

  if(argc < 4 || argc > 5)
    CLE; /* Wrong nr of arguments */

  p.n2 = chkIfDigit(argv[0]); /* Outer code - length */
  p.M = chkIfDigit(argv[1]);  /* Outer code - #codewords */
  p.q = chkIfDigit(argv[2]);  /* Inner code - #codewords
                                 Outer code - Alphabet */
  p.r = chkIfDigit(argv[3]);  /* Inner code - replication factor */
  p.n1 = p.r * (p.q-1);       /* Inner code - length */

 /* Check for collusion-size parameter */
  p.t = (argc == 5) ? chkIfDigit(argv[4]) : 0;

  /* ICepsilon and expr are used in the tracing algorithm alg1 */
  //p.ICepsilon = pow(2,logB2(2*p.q)-(p.r/(2 * pow(p.q,2)))); /* T.V.1 */
  p.ICepsilon = ((2 * p.q) * pow(2,-(p.r/(2 * pow(p.q,2))))); /* T.V.1 */
  p.expr = (logB2((2*p.q)/p.ICepsilon)); /* Constant */
 
  return p;
}

/* Check command-line input. Must be a digit */
/*int chkIfDigit(char argv[])
{
  int i;

  for(i=0;i<strlen(argv);i++)
    if(!isdigit(argv[i])) {
      printf("n2, M, q, r and t(optional) must be numbers.\n");
      CLE;
    }

  return atoi(argv);
}*/

/* Calculate code properties */
cParam setProp(cParam p)
{
  int i;

  /* Check nr of bits we need for each nr in the outer code */
  for(i=0;i<BS_WORD;i++)
    if ((p.q & (word)1<<i) > 0)
      p.nrOfBits = i+1;

  /* # numbers we can store in each block(in each unsigned long)
     of the Outer code */
  p.nrInBlockOC = BS_WORD/p.nrOfBits;

  /* Set number of blocks in Outer code */
  p.nrOfBlocksOC = (p.n2 % p.nrInBlockOC) == 0 ?
  		p.n2/(p.nrInBlockOC) : (p.n2/(p.nrInBlockOC))+1;

  /* Set size of last block in Outer Code  */
  p.lenLastBlockOC = p.n2-((p.nrOfBlocksOC-1)*p.nrInBlockOC);

  /* Set number of blocks in Inner code */
  p.nrOfBlocksIC = (p.n1 % BS_DWORD) == 0 ?
  		p.n1/BS_DWORD : (p.n1/BS_DWORD) + 1;
  
  /* Set size of last block in Inner Code  */
  p.lenLastBlockIC = p.n1-(BS_DWORD*(p.nrOfBlocksIC-1));

  return p;
}
